'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (routeConfig) {
  var apis = routeConfig.apis;


  if (!apis || Array.isArray(apis) && !apis.length) {
    throw new Error('Invalid routes configuration.');
  }

  apis.forEach(function (api) {
    var method = api.method.toLowerCase();
    if (validMethods.indexOf(method) === -1) {
      throw new Error('Invalid http method ' + api.method);
    }

    router[method](api.path, function (req, res, next) {
      return res.json(api.data);
    });

    if (api.withParam) {
      router[method](api.path + '/:id', function (req, res, next) {
        var data = api.data.filter(function (data) {
          return data.id = req.params.id;
        })[0] || {};
        return res.json(data);
      });
    }
  });

  return router;
};

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var router = _express2.default.Router();

// Only support get method :)
var validMethods = ['get'];