'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _ngrok = require('ngrok');

var _ngrok2 = _interopRequireDefault(_ngrok);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _readConfig = require('./readConfig');

var _readConfig2 = _interopRequireDefault(_readConfig);

var _createRoute = require('./createRoute');

var _createRoute2 = _interopRequireDefault(_createRoute);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function _callee(_ref) {
  var config = _ref.config,
      port = _ref.port,
      useNgrok = _ref.useNgrok;
  var app, jsonConfig, apiRoutes;
  return _regenerator2.default.async(function _callee$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          app = (0, _express2.default)();

          // Load json config.

          _context.prev = 1;
          _context.next = 4;
          return _regenerator2.default.awrap((0, _readConfig2.default)(config));

        case 4:
          jsonConfig = _context.sent;
          apiRoutes = (0, _createRoute2.default)(jsonConfig);

          app.use(apiRoutes);
          _context.next = 13;
          break;

        case 9:
          _context.prev = 9;
          _context.t0 = _context['catch'](1);

          console.error(_context.t0);
          process.exit(-1);

        case 13:

          app.listen(port, function () {
            console.log(_chalk2.default.green('[INFO] Server is listening on port ' + port));

            if (useNgrok) {
              _ngrok2.default.connect(port, function (err, url) {
                console.log(_chalk2.default.green('[INFO] ngrok URL is ' + url));
                require("openurl").open(url);
              });
            }
          });

          return _context.abrupt('return', app);

        case 15:
        case 'end':
          return _context.stop();
      }
    }
  }, null, this, [[1, 9]]);
};